(ns wanijo.neo4j
  (:require [clojurewerkz.neocons.rest :as nr]
            [clojurewerkz.neocons.rest.nodes :as nrn]
            [clojurewerkz.neocons.rest.cypher :as cypher]
            [wanijo.devmode :as devmode]))

(def conn
  (delay (nr/connect "http://neo4j:b@localhost:7474/db/data")))

(defn conn! []
  @conn)

(defn butiful-query [qry]
  (->> qry
       clojure.string/trim-newline
       clojure.string/split-lines
       (map clojure.string/trim)
       (filter #(> (count %) 0))
       (clojure.string/join \newline)))

(defn query-rawdata!
  [& {:keys [query alias params]
      :or {params {}}}]
  (devmode/send-to-bar (str (butiful-query query)
                            "<br>---Params---<br>"
                            params))
  (->>
   (cypher/tquery (conn!) query params)
   (map #(get % alias))
   (map :data)))

(defn find-user! [ident]
  (query-rawdata!
   :query
   "MATCH (n:user)
    WHERE n.ident = {ident}
    RETURN n"
   :alias "n"
   :params {:ident ident}))
